/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.alibaba.fastjson.JSON
 *  com.deepexi.scd.calculate.domain.dto.CalculateDataFillDTO
 *  com.deepexi.scd.calculate.domain.query.CalculateDataFillQuery
 *  com.deepexi.scd.calculate.remote.analysis.AnalysisSyncRemote
 *  com.deepexi.scd.calculate.service.CalculateDataFillAnalysisService
 *  com.deepexi.scd.calculate.service.CalculateDataFillService
 *  com.deepexi.scd.calculate.service.CalculateDataFillTaskService
 *  com.deepexi.scd.common.enums.business.SourceTypeEnum
 *  com.deepexi.scd.common.system.AppRuntimeEnv
 *  com.deepexi.spa.commons.utils.CollectionUtils
 *  com.google.api.client.util.Joiner
 *  com.google.api.client.util.Lists
 *  org.apache.rocketmq.common.message.MessageExt
 *  org.apache.rocketmq.spring.annotation.RocketMQMessageListener
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.beans.factory.annotation.Value
 *  org.springframework.boot.autoconfigure.condition.ConditionalOnProperty
 *  org.springframework.stereotype.Component
 *  org.springframework.transaction.annotation.Transactional
 */
package com.deepexi.scd.calculate.mq.consumer;

import com.alibaba.fastjson.JSON;
import com.deepexi.scd.calculate.domain.dto.CalculateDataFillDTO;
import com.deepexi.scd.calculate.domain.query.CalculateDataFillQuery;
import com.deepexi.scd.calculate.mq.consumer.AbstractConsumer;
import com.deepexi.scd.calculate.remote.analysis.AnalysisSyncRemote;
import com.deepexi.scd.calculate.service.CalculateDataFillAnalysisService;
import com.deepexi.scd.calculate.service.CalculateDataFillService;
import com.deepexi.scd.calculate.service.CalculateDataFillTaskService;
import com.deepexi.scd.common.enums.business.SourceTypeEnum;
import com.deepexi.scd.common.system.AppRuntimeEnv;
import com.deepexi.spa.commons.utils.CollectionUtils;
import com.google.api.client.util.Joiner;
import com.google.api.client.util.Lists;
import java.nio.charset.StandardCharsets;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Optional;
import java.util.stream.Collectors;
import org.apache.rocketmq.common.message.MessageExt;
import org.apache.rocketmq.spring.annotation.RocketMQMessageListener;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

@Component
@RocketMQMessageListener(nameServer="${deepexi.scd.rocketmq.name-server}", topic="${deepexi.scd.rocketmq.topic.approve}", consumerGroup="${deepexi.scd.rocketmq.consumer.approve.group}")
@ConditionalOnProperty(prefix="deepexi.scd.rocketmq", value={"enable"}, havingValue="true", matchIfMissing=true)
public class FillApprovePassConsumer
extends AbstractConsumer {
    private static final Logger log = LoggerFactory.getLogger(FillApprovePassConsumer.class);
    @Value(value="${deepexi.scd.rocketmq.topic.approve}")
    private String topic;
    @Autowired
    private AnalysisSyncRemote analysisSyncRemote;
    @Autowired
    private CalculateDataFillService calculateDataFillService;
    @Autowired
    private CalculateDataFillAnalysisService calculateDataFillAnalysisService;
    @Autowired
    private CalculateDataFillTaskService calculateDataFillTaskService;
    @Autowired
    private AppRuntimeEnv appRuntimeEnv;

    @Override
    @Transactional(rollbackFor={Exception.class})
    protected void readMessage(MessageExt message) {
        String body = new String(message.getBody(), StandardCharsets.UTF_8);
        log.info("引擎接口发送审核通过的数据为消费数据为：{}", (Object)body);
        List list = Optional.ofNullable(JSON.parseArray((String)body, CalculateDataFillDTO.class)).orElse(Lists.newArrayList());
        list = list.stream().filter(item -> {
            String cycle = item.getCycle();
            String[] split = cycle.trim().split("-");
            return split.length > 1;
        }).collect(Collectors.toList());
        if (CollectionUtils.isEmpty(list)) {
            return;
        }
        Map<String, List<CalculateDataFillDTO>> map = list.stream().collect(Collectors.groupingBy(CalculateDataFillDTO::getCycle));
        map.forEach((key, values) -> {
            List unitIds = values.stream().filter(item -> Objects.nonNull(item.getEnterpriseUnitId())).map(CalculateDataFillDTO::getEnterpriseUnitId).distinct().collect(Collectors.toList());
            if (CollectionUtils.isEmpty(unitIds)) {
                return;
            }
            this.analysisSyncRemote.removeByEnterpriseUnitIdsAndYear(Joiner.on((char)',').join(unitIds), key);
        });
        this.appRuntimeEnv.setLoginType(SourceTypeEnum.SYSTEM.name());
        List fillIds = list.stream().map(CalculateDataFillDTO::getFillId).distinct().collect(Collectors.toList());
        CalculateDataFillQuery calculateDataFillQuery = new CalculateDataFillQuery();
        calculateDataFillQuery.setFillIds(fillIds);
        List fillList = this.calculateDataFillService.findList(calculateDataFillQuery);
        if (CollectionUtils.isEmpty((Collection)fillList)) {
            return;
        }
        this.calculateDataFillAnalysisService.syncAnalysisDataAsync(fillList, Boolean.valueOf(false));
        this.calculateDataFillTaskService.updateFillTaskStatus(fillList.stream().map(CalculateDataFillDTO::getFillTaskId).collect(Collectors.toList()));
    }

    @Override
    protected String getTopic() {
        return this.topic;
    }

    public static void main(String[] args) {
        String body = "[{\"approveDate\":1666252597323,\"cycle\":\"2022-08\",\"cycleMonth\":\"08\",\"enterpriseId\":102,\"enterpriseUnitId\":371,\"fillId\":10852,\"fillTaskId\":121,\"fillTime\":1666252597323,\"industry\":\"5611\",\"isAnalysis\":0,\"standardId\":10470,\"status\":\"FS5\",\"updatedAt\":1666252597357}]";
        List list = Optional.ofNullable(JSON.parseArray((String)body, CalculateDataFillDTO.class)).orElse(Lists.newArrayList());
        System.out.println(list);
    }
}

